
int tileW = 60;
int tileH = 60;

int nrow = 3;
int ncol = 6;


Tile[][] table = new Tile[nrow][ncol];

void setup()
{
  int dir = 0;
  size(tileW*ncol,tileH*nrow);
  background(100);


  for (int i = 0; i<nrow; i++)
  {
    for (int j = 0; j<ncol; j++)
    {
      Tile t = new Tile((int)random(2),(int)random(4),i,j);
      table[i][j] = t;
    }
  }


}

void draw()
{
  for (int i = 0; i<nrow; i++)
  {
    for (int j = 0; j<ncol; j++)
    {
      table[i][j].draw();
    }
  }
}


class Tile {

  // 0 : courb, 1 : droit
  private int shape;

  // 0 : haut, 1 : droit, 2 : bas, 3 : gauche
  private int dir;

  // numro de ligne >= 0
  private int raw;

  // numro de colonne >= 0
  private int column;

  public Tile(int shape, int dir, int raw, int column)
  {
    this.shape = shape;
    this.raw = raw;
    this.dir = dir;
    this.column = column;

  }

  public void draw()
  {
    pushMatrix();
    translate(column*tileW,raw*tileH);
    fill(255);
    stroke(255,0,0);
    strokeWeight(1);    
    rect(0,0,tileW,tileH);
    switch (shape)
    {
    case 0:
      stroke(0,255,0);  
      strokeWeight(2);   
      noFill(); 
      //rotate(dir*PI/2.0);      
      arc(0,0,tileW,tileH,0,PI/2);
      break;
    case 1:
      stroke(0,255,0);  
      strokeWeight(2);    
      translate(tileW/2,tileH/2);
      rotate(dir*PI/2.0);      
      line(-tileW/2,0,tileW/2,0);    
      break;
    }
    popMatrix();

  }

}
